/**
 * These types have been generated from the JSON structure of the current entries in catalog.json
 */
export type CatalogEntries = Array<CatalogEntry>;

export type BaseCatalogEntry = {
  key: string;
  title: string;
};

export type CatalogEntry = BaseCatalogEntry & {
  children: ChildCatalogEntry[];
  folder: boolean;
};

export type ChildCatalogEntry = BaseCatalogEntry & {
  icon: string;
  tooltip: string;
};

/**
 * An object that only has properties of the provided type
 */
export type Dictionary<T, TKey extends string = string> = {
  [index in TKey]: T;
};
